@echo off

setlocal

set CabFile=%~1

if "%CabFile%" == "" (

  echo WinCE CAB file arch/ver reset in MSCE header
  echo.
  echo Argument: CAB file name or path
  echo.
  echo Note: cabarc utility must be available.

  exit /b 1

)

for %%F in ("%CabFile%") do (

  if not exist "%%~fF" (

    echo File "%%~fF" does not exist
    pause
    exit /b 1

  )

  if /i not "%%~xF" == ".cab" (

    echo File "%%~fF" has no CAB extension
    pause
    exit /b 1

  )

)

set TargetDir=$tmp$%random%

if exist "%TargetDir%" (

  echo Directory "%TargetDir%" already exists
  pause
  exit /b 1

)

md "%TargetDir%"

if errorlevel 1 (

  echo Cannot create directory "%TargetDir%"
  pause
  exit /b 1

)

cabarc x "%CabFile%" * %TargetDir%\

if errorlevel 1 (

  pause
  goto Cleanup

)

for %%F in ("%TargetDir%\*.000") do (

  mscetool c -arch 0 -vermin 0 -vermax 0 "%%~fF"

  if errorlevel 1 (

    pause
    goto Cleanup

  )

)

for %%F in ("%CabFile%") do (

  cabarc -m none n "%%~dpnF_unrestricted.cab" %TargetDir%\*

  if errorlevel 1 (

    pause
    goto Cleanup

  )

)

:Cleanup

if exist "%TargetDir%" (

  rd /s /q "%TargetDir%"

)
